(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("ts-di-transformer", [], factory);
	else if(typeof exports === 'object')
		exports["ts-di-transformer"] = factory();
	else
		root["ts-di-transformer"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src.bundle/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src.bundle/index.ts":
/*!*****************************!*\
  !*** ./src.bundle/index.ts ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(/*! ../src/api */ "./src/api.ts"));


/***/ }),

/***/ "./src/api.ts":
/*!********************!*\
  !*** ./src/api.ts ***!
  \********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Container = /** @class */ (function () {
    function Container(parentContainer) {
        this._map = new Map();
        this._parentContainer = parentContainer;
    }
    Container.prototype.get = function (key) {
        var isMultiInject = Array.isArray(key);
        if (Array.isArray(key)) {
            if (key.length > 0) {
                key = key[0];
            }
            else {
                throw new Error("Invalid multi inject of `" + key.toString() + "`.");
            }
        }
        var entries = this._map.get(key);
        if (isMultiInject && (!entries || entries.length === 0)) {
            return [];
        }
        if (!entries || entries.length === 0) {
            if (this._parentContainer) {
                return this._parentContainer.get(key);
            }
            throw new Error("Missing binding of `" + key.toString() + "`.");
        }
        var resolvedEntries = [];
        for (var _i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
            var entry = entries_1[_i];
            if (entry.kind === 'newable' && !entry.value) {
                entry.value = this.resolve(entry.newable, entry.params);
            }
            if (entry.kind === 'factory' && !entry.value) {
                entry.value = entry.factory(this);
            }
            if (isMultiInject) {
                resolvedEntries.push(entry.value);
            }
            else {
                return entry.value;
            }
        }
        return resolvedEntries;
    };
    Container.prototype.bind = function (serviceIdentifier, constructor, params) {
        if (params === void 0) { params = []; }
        var entries = this._map.get(serviceIdentifier) || [];
        entries.push({
            kind: 'newable',
            newable: constructor,
            params: params
        });
        this._map.set(serviceIdentifier, entries);
    };
    Container.prototype.bindToConstant = function (serviceIdentifier, constant) {
        var entries = this._map.get(serviceIdentifier) || [];
        entries.push({
            kind: 'constant',
            value: constant
        });
        this._map.set(serviceIdentifier, entries);
    };
    /**
     * Bind the implementations of the class to the class.
     * @param constructor
     * @param params
     * @param serviceIdentifiers
     */
    Container.prototype.bindToImplements = function (constructor, params, serviceIdentifiers) {
        if (params === void 0) { params = []; }
        if (serviceIdentifiers === void 0) { serviceIdentifiers = []; }
        var entry = {
            kind: 'newable',
            newable: constructor,
            params: params
        };
        for (var _i = 0, serviceIdentifiers_1 = serviceIdentifiers; _i < serviceIdentifiers_1.length; _i++) {
            var serviceIdentifier = serviceIdentifiers_1[_i];
            var entries = this._map.get(serviceIdentifier) || [];
            entries.push(entry);
            this._map.set(serviceIdentifier, entries);
        }
    };
    Container.prototype.bindToFactory = function (serviceIdentifier, factory) {
        var entries = this._map.get(serviceIdentifier) || [];
        entries.push({
            kind: 'factory',
            factory: factory
        });
        this._map.set(serviceIdentifier, entries);
    };
    Container.prototype.resolve = function (service, params) {
        if (params === void 0) { params = []; }
        var args = [];
        for (var _i = 0, params_1 = params; _i < params_1.length; _i++) {
            var val = params_1[_i];
            args.push(this.get(val));
        }
        return new (service.bind.apply(service, [void 0].concat(args)))();
    };
    Container.prototype.resolveFactory = function (service, params) {
        if (params === void 0) { params = []; }
        var args = [];
        for (var _i = 0, params_2 = params; _i < params_2.length; _i++) {
            var val = params_2[_i];
            args.push(this.get(val));
        }
        return service.bind.apply(service, [undefined].concat(args));
    };
    return Container;
}());
exports.Container = Container;


/***/ })

/******/ });
});
//# sourceMappingURL=ts-di-transformer.umd.js.map